import { emit, EventEmitter } from "../../event-emitter";
let hidCache;
export default async function hidAsyncWorker() {
    if (hidCache) {
        return hidCache;
    }
    // tslint:disable-next-line:max-classes-per-file
    class CustomMessagePort extends EventEmitter {
        constructor() {
            super(...arguments);
            this.target = undefined;
        }
        postMessage(data) {
            this.target[emit]("message", data);
        }
    }
    const containers = new Map();
    const port0 = new CustomMessagePort();
    const port1 = new CustomMessagePort();
    port0.target = port1;
    port1.target = port0;
    port1.on("message", (msg) => {
        if (!msg.p && msg.t === "n" && typeof msg.d === "string" && !containers.has(msg.d)) {
            const Hid = require("../hid-container").HidContainer;
            const hid = new Hid(msg.d, port1);
            containers.set(msg.d, hid);
            hid.init();
        }
    });
    port0.containers = containers;
    Promise.resolve().then(() => port1.postMessage({ t: "ready" }));
    return hidCache = Promise.resolve(port0);
}
export function devices() {
    return import("node-hid").then((hid) => hid.devices());
}
//# sourceMappingURL=hid-async-emulated.js.map