"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _a;
"use strict";
const symListeners = Symbol("emitterListeners");
exports.emit = Symbol("emitterEmit");
class EventEmitter {
    constructor() {
        this[_a] = new Map();
    }
    on(event, cb) {
        const lm = this[symListeners];
        let lst = lm.get(event);
        if (!lst) {
            lm.set(event, lst = [[], []]);
        }
        lst[0].push(cb);
        return this;
    }
    once(event, cb) {
        const lm = this[symListeners];
        let lst = lm.get(event);
        if (!lst) {
            lm.set(event, lst = [[], []]);
        }
        lst[0].push(cb);
        lst[1].push(cb);
        return this;
    }
    off(event, cb) {
        const lm = this[symListeners];
        const lst = lm.get(event);
        if (!lst) {
            return this;
        }
        const p = lst[0].indexOf(cb);
        if (p !== -1) {
            lst[0].splice(p, 1);
        }
        return this;
    }
    [(_a = symListeners, exports.emit)](event, arg) {
        const lm = this[symListeners];
        const lst = lm.get(event);
        if (!lst) {
            return 0;
        }
        const [ls, ols] = lst;
        let cnt = 0;
        for (const f of ls) {
            f.call(this, arg);
            cnt++;
        }
        if (ols.length) {
            for (const f of ols) {
                const p = ls.indexOf(f);
                if (p !== -1) {
                    ls.splice(p, 1);
                }
            }
            ols.length = 0;
        }
        return cnt;
    }
}
EventEmitter.emitSymbol = exports.emit;
exports.EventEmitter = EventEmitter;
//# sourceMappingURL=event-emitter.js.map