"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const event_emitter_1 = require("../../event-emitter");
let hidCache;
async function hidAsyncWorker() {
    if (hidCache) {
        return hidCache;
    }
    // tslint:disable-next-line:max-classes-per-file
    class CustomMessagePort extends event_emitter_1.EventEmitter {
        constructor() {
            super(...arguments);
            this.target = undefined;
        }
        postMessage(data) {
            this.target[event_emitter_1.emit]("message", data);
        }
    }
    const containers = new Map();
    const port0 = new CustomMessagePort();
    const port1 = new CustomMessagePort();
    port0.target = port1;
    port1.target = port0;
    port1.on("message", (msg) => {
        if (!msg.p && msg.t === "n" && typeof msg.d === "string" && !containers.has(msg.d)) {
            const Hid = require("../hid-container").HidContainer;
            const hid = new Hid(msg.d, port1);
            containers.set(msg.d, hid);
            hid.init();
        }
    });
    port0.containers = containers;
    Promise.resolve().then(() => port1.postMessage({ t: "ready" }));
    return hidCache = Promise.resolve(port0);
}
exports.default = hidAsyncWorker;
function devices() {
    return Promise.resolve().then(() => __importStar(require("node-hid"))).then((hid) => hid.devices());
}
exports.devices = devices;
//# sourceMappingURL=hid-async-emulated.js.map