"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const hid_container_1 = require("../hid-container");
const containers = new Map();
let msgatt = false;
const parentPort = {
    on(event, listener) {
        if (!msgatt) {
            const f = (msg) => {
                if (msg.d && !(msg.d instanceof Uint8Array) && msg.d.type === "Buffer") {
                    msg.d = msg.d.data;
                }
                listener(msg);
            };
            process.on(event, f);
            msgatt = true;
        }
        process.on(event, listener);
        return this;
    },
    off(event, listener) {
        process.off(event, listener);
        return this;
    },
    postMessage(data) {
        if (!process.send) {
            throw new Error("process.send is undefined");
        }
        process.send(data);
    },
};
parentPort.on("message", (msg) => {
    if (!msg.p && msg.t === "n" && typeof msg.d === "string" && !containers.has(msg.d)) {
        const hid = new hid_container_1.HidContainer(msg.d, parentPort);
        containers.set(msg.d, hid);
        hid.init();
    }
    else if (!msg.p && msg.t === "d") {
        Promise.resolve().then(() => __importStar(require("node-hid"))).then((hid) => {
            parentPort.postMessage({ t: "d", d: hid.devices() });
        });
    }
});
parentPort.postMessage({ t: "ready" });
//# sourceMappingURL=hid-process.js.map