import { StreamDeck } from "../stream-deck";
import { IImageLibrary } from "../image-library";
export declare const DEV_VENDOR = 4057;
export declare const DEV_PRODUCT = 99;
export default class ElgatoStreamDeckMini extends StreamDeck {
    readonly iconSize = 80;
    readonly buttonColumns = 3;
    readonly buttonRows = 2;
    readonly buttonLength: number;
    readonly buttonLayout: number[][];
    protected readonly pagePacketSize = 1024;
    constructor(devicePath: string);
    fillImage(keyIndex: number, imageBuffer: Uint8Array): Promise<number>;
    protected writeImagePage(keyIndex: number, pixels: Uint8Array): Promise<number>;
    protected processImage(image: IImageLibrary): Promise<Uint8Array>;
    /**
     * Writes a Stream Deck's page 0 headers and image data to the Stream Deck.
     *
     * @private
     * @param {number} keyIndex The key to write to 0 - 14
     * @returns {Promise<number>}
     */
    protected _writePage0(keyIndex: number, pixels: Uint8Array): Promise<number>;
}
