import { StreamDeck } from "../stream-deck";
export declare const DEV_VENDOR = 4057;
export declare const DEV_PRODUCT = 96;
export default class ElgatoStreamDeck extends StreamDeck {
    readonly iconSize = 72;
    readonly buttonColumns = 5;
    readonly buttonRows = 3;
    readonly buttonLength: number;
    readonly buttonLayout: number[][];
    protected readonly pagePacketSize = 8191;
    constructor(devicePath: string);
    protected writeImagePage(keyIndex: number, pixels: Uint8Array): Promise<number>;
    /**
     * Writes a Stream Deck's page 1 headers and image data to the Stream Deck.
     *
     * @private
     * @param {number} keyIndex The key to write to 0 - 14
     * @param {Uint8Array} pixels Full image data for extraction to page 1
     * @returns {Promise<number>}
     */
    protected _writePage1(keyIndex: number, pixels: Uint8Array): Promise<number>;
    /**
     * Writes a Stream Deck's page 2 headers and image data to the Stream Deck.
     *
     * @private
     * @param {number} keyIndex The key to write to 0 - 14
     * @param {Uint8Array} pixels Image data for page 2
     * @returns {Promise<number>}
     */
    protected _writePage2(keyIndex: number, pixels: Uint8Array): Promise<number>;
}
